﻿const mm = 72/25.4;
var doc = app.activeDocument;
var dialogStr = 'Write Printpreset name';
var NamePreset = 'offset';
var PrintPath = '/D/Паша/_PS/in/';
var NameLayerPrint = true;
var XposNameLayer = 2*mm;
var YposNameLayer = 0;

var RegClr = new SpotColor();
	RegClr.spot = doc.spots['[Registration]'];
	
origin = doc.rulerOrigin;

if (documents.length > 0){
	if (str = prompt (dialogStr, NamePreset)) {
		NamePreset = str;		
		h = doc.height;
		w = doc.width;
		
		var printOpts = new PrintOptions;
		printOpts.printPreset = NamePreset;
					
		var printJobOptions= new PrintJobOptions();
		printJobOptions.file = '';
		printOpts.jobOptions = printJobOptions;		
					
		for (i=0; i<doc.layers.length; i++)
			if (doc.layers[i].locked == false) doc.layers[i].visible = false;
		fullDocName = doc.fullName;
		var param = doc.name.split('.');
		realDocName = param[0];
		sum = 0;
		if (doc.layers[0].locked == false) {
			doc.layers[0].visible = true;					
			docName = PrintPath+realDocName+'_'+doc.layers[0].name+'.ps';
			shortName = realDocName+'_'+doc.layers[0].name;
			PrintLayer (docName,shortName,0,NameLayerPrint,XposNameLayer,YposNameLayer);
			sum = 0;
			}		
		for (i=1; i<doc.layers.length; i++){
			if (doc.layers[i-1].locked == false) doc.layers[i-1].visible = false;
			if (doc.layers[i].locked == false) {
				doc.layers[i].visible = true;													
				docName = PrintPath+realDocName+'_'+doc.layers[i].name+'.ps';
				shortName = realDocName+'_'+doc.layers[i].name;
				PrintLayer (docName,shortName,i,NameLayerPrint,XposNameLayer,YposNameLayer);
				sum = i;
			}			
		}
		doc.layers[sum].visible = true;			
	}
}

function PrintLayer (docName,shortName,i,a,x1,y1){
	if (a) {			
		var textPos = Array (x1,y1);
	 	var textStr = doc.layers[i].textFrames.pointText(textPos);
		textStr.textRange.characterAttributes.size = 8;
		textStr.textRange.characterAttributes.fillColor = RegClr;
	 	textStr.rotate (90);
	 	textStr.contents = shortName;	
	}
	var docPath = new File(docName);				
	printJobOptions.file = docPath;					
	doc.print(printOpts);
	if (a) textStr.remove();
}

